﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml.Linq;

namespace Kalendarz
{
    /// <summary>
    /// Logika interakcji dla klasy MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            utworzTemplate(); //utworzenie plików 
            DzisiejszaData(); //zapisuje dziszejsza date i ostatni dzien miesiaca do tabDD
            ustaw_dane(); //ustawia miesiac i rok w gornym textblocku
            utworzGrida(); //tworzy siatke dat
            wstawDniTygodnia(); //wstawia dni tygodnia
            wypelnijGrida(); //wypelnia siatke dat
            odczytajDatyDomyslne(); //wczytuje daty swiat
            odczytajDatyUsera(); //wczytuje daty uzytkownika
        }

        string[] tab = { "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday", "Sunday" };
        string[] mies = { "January", "February", "March", "April","May","June","July","August","September","October","November","December" };
        int count = 1;
        int offset = 0;
        string input;
        public bool czy_pusty = true;

        Window poup = new Window();
        TextBox tekst = new TextBox();
        Grid cos = new Grid();
        string pomoc;

        string[] tabDD = new string[5];
        string zawartosc;
        public object Int { get; private set; }
        private void utworzTemplate()
        {
            if (!File.Exists("daty_def.txt"))
            {
                using (StreamWriter tw = File.CreateText("daty_def.txt"))
                {
                    tw.WriteLine("101|Nowy Rok\n601|Trzech Króli\n104|Primma Aprilis\n105|Święto Pracy\n305|Dzień Konstytucji 3 Maja\n1508|Wniebowzięcie Najwiętrzej Marii Panny\n111|Wszystkich Świętych\n211|Dzień Zaduszny\n1111|Dzień Niepodledłości\n2412|Wigilia Swiat Bozego Narodzenia\n2512|Boze Narodzenie\n2612|Swietego Szczepana\n3112|Sylwester");
                }
            }
            if (!File.Exists("daty.txt"))
            {
                File.CreateText("daty.txt");
            }
        }
        private void DzisiejszaData()
        {
            var startDate = new DateTime(DateTime.Now.Year, DateTime.Now.Month, 1);
            string dzisiejszaData = DateTime.Now.ToString("dd");
            string dzisiejszyMiesiac = DateTime.Now.ToString("MM");
            string dzisiejszyRok = DateTime.Now.ToString("yyyy");
            string dzisiejszyDT = startDate.DayOfWeek.ToString();
            string ostatnidzień = new DateTime(DateTime.Now.Year, DateTime.Now.Month, 1).AddMonths(1).AddDays(-1).ToString("dd");

            tabDD[0] = dzisiejszaData;
            tabDD[1] = dzisiejszyMiesiac;
            tabDD[2] = dzisiejszyRok;
            tabDD[3] = dzisiejszyDT;
            tabDD[4] = ostatnidzień;
        }
        public void ustaw_dane()
        {
            top.Text = mies[Int32.Parse(tabDD[1]) - 1] + " " + tabDD[2];
        }
        private void utworzGrida()
        {
            for (int i = 0; i < 7; i++)
            {
                ColumnDefinition gridCol = new ColumnDefinition();
                gr.ColumnDefinitions.Add(gridCol);
            }
            for (int i = 0; i < 7; i++)
            {
                RowDefinition gridRow = new RowDefinition();
                gridRow.Height = new GridLength(55);
                gr.RowDefinitions.Add(gridRow);
            }
        }
        private void wstawDniTygodnia()
        {
            for (int i = 0; i < 7; i++)
            {
                TextBlock txtBlock = new TextBlock();
                txtBlock.Text = tab[i];
                txtBlock.TextAlignment = TextAlignment.Center;
                txtBlock.FontSize = 20;
                Grid.SetRow(txtBlock, 0);
                Grid.SetColumn(txtBlock, i);
                gr.Children.Add(txtBlock);
            }
        }
        public int dzień()
        {
            int indeks = 0;
            for (int i = 0; i < 7; i++)
            {
                if (tabDD[3] == tab[i])
                {
                    indeks = i;
                    break;
                }
            }
            return indeks;
        }
        private void wypelnijGrida()
        {
            for (int i = 1; i < 7; i++)
            {
                if (i == 1)
                {
                    for (int j = dzień(); j < 7; j++)
                    {
                        if ((count - 1).ToString() == tabDD[4]) break;
                        Button guzik = new Button();
                        guzik.Background = Brushes.LightGreen;
                        guzik.Content = count.ToString();
                        if (j == 6)
                        {
                            guzik.Foreground = Brushes.Red;
                        }
                        if (j == 5)
                        {
                            guzik.Foreground = Brushes.Gray;
                        }
                        if (count.ToString() == tabDD[0] && offset == 0)
                        {
                            guzik.Foreground = Brushes.Green;
                            guzik.Background = Brushes.LightPink;
                            zawartosc = tabDD[0];
                        }
                        if (count.ToString() + tabDD[1] == "101" || count.ToString() + tabDD[1] == "601" || count.ToString() + tabDD[1] == "105"
                            || count.ToString() + tabDD[1] == "305" || count.ToString() + tabDD[1] == "1508" ||
                            count.ToString() + tabDD[1] == "111" || count.ToString() + tabDD[1] == "1111" ||
                                count.ToString() + tabDD[1] == "2512" || count.ToString() + tabDD[1] == "2612")
                        {
                            guzik.Foreground = Brushes.Red;
                        }
                        guzik.FontSize = 20;

                        guzik.Click += btn_Click;
                        Grid.SetRow(guzik, i);
                        Grid.SetColumn(guzik, j);
                        gr.Children.Add(guzik);
                        count++;
                    }
                }
                else
                {
                    for (int j = 0; j < 7; j++)
                    {
                        if ((count - 1).ToString() == tabDD[4]) break;
                        Button guzik = new Button();
                        guzik.Background = Brushes.LightGreen;
                        guzik.Content = count.ToString();
                        if (j == 6)
                        {
                            guzik.Foreground = Brushes.Red;
                        }
                        if (j == 5)
                        {
                            guzik.Foreground = Brushes.Gray;
                        }
                        if (count.ToString() == tabDD[0] && offset == 0)
                        {
                            guzik.Foreground = Brushes.Green;
                            guzik.Background = Brushes.LightPink;
                            zawartosc = tabDD[0];
                        }
                        if (count.ToString() + tabDD[1] == "101" || count.ToString() + tabDD[1] == "601" || count.ToString() + tabDD[1] == "105"
                            || count.ToString() + tabDD[1] == "305" || count.ToString() + tabDD[1] == "1508" ||
                            count.ToString() + tabDD[1] == "111" || count.ToString() + tabDD[1] == "1111" ||
                                count.ToString() + tabDD[1] == "2512" || count.ToString() + tabDD[1] == "2612")
                        {
                            guzik.Foreground = Brushes.Red;
                        }
                        guzik.FontSize = 20;

                        guzik.Name = "guzik" + count.ToString();
                        guzik.Click += btn_Click;
                        Grid.SetRow(guzik, i);
                        Grid.SetColumn(guzik, j);
                        gr.Children.Add(guzik);
                        count++;
                    }
                }
            }
            count = 1;
        }
        private void odczytajDatyDomyslne()
        {
            string czytaj;
            string[] dziel;
            StreamReader tr = new StreamReader("daty_def.txt");
            while (!tr.EndOfStream)
            {
                czytaj = tr.ReadLine();
                dziel = czytaj.Split('|');
                if (dziel[0] == (zawartosc + tabDD[1]))
                {
                    czy_pusty = false;
                    bot.Text = dziel[1];
                    break;
                }
                else bot.Text = "";
            }
            tr.Close();
        }
        private void odczytajDatyUsera()
        {
            string czytaj;
            string[] dziel;
            StreamReader tr = new StreamReader("daty.txt");
            while (!tr.EndOfStream)
            {
                czytaj = tr.ReadLine();
                dziel = czytaj.Split('|');
                if (dziel[0] == (zawartosc + tabDD[1]+tabDD[2]))
                {
                    bot.Text += dziel[1];
                    pomoc = dziel[1];
                    break;
                }
            }
            tr.Close();
        }
        private void NastepnaData(int o)
        {
            var startDate = new DateTime(DateTime.Now.Year,DateTime.Now.Month, 1).AddMonths(o);
            string nastepnyMiesiac = new DateTime(DateTime.Now.Year, DateTime.Now.Month, 1).AddMonths(o).ToString("MM");
            string nastepnyRok = new DateTime(DateTime.Now.Year, DateTime.Now.Month, 1).AddMonths(o).ToString("yyyy");
            string nastepnyDT = startDate.DayOfWeek.ToString();
            string ostatnidzień = new DateTime(DateTime.Now.Year, DateTime.Now.Month, 1).AddMonths(o+1).AddDays(-1).ToString("dd");

            tabDD[1] = nastepnyMiesiac;
            tabDD[2] = nastepnyRok;
            tabDD[3] = nastepnyDT;
            tabDD[4] = ostatnidzień;
        }

        private void btn_Click(object sender, RoutedEventArgs e)
        {
            zawartosc = (sender as Button).Content.ToString();
            odczytajDatyDomyslne();
            odczytajDatyUsera();
        }
        private void Kliknij_Przod(object sender, RoutedEventArgs e)
        {
            offset++;
            gr.Children.Clear();
            wstawDniTygodnia();
            NastepnaData(offset);
            wypelnijGrida();
            ustaw_dane();
            bot.Text="";
        }
        private void Kliknij_Tyl(object sender, RoutedEventArgs e)
        {
            offset--;
            gr.Children.Clear();
            wstawDniTygodnia();
            NastepnaData(offset);
            wypelnijGrida();
            ustaw_dane();
            bot.Text="";
        }
        private void Dodaj(object sender, RoutedEventArgs e) //nowe okienko
        {
            poup.Height = 200;
            poup.Width = 800;
            Button guz = new Button();
            Grid.SetRow(tekst, 0);
            Grid.SetRow(guz, 1);
            tekst.Width = 700;
            tekst.Background = Brushes.AliceBlue;
            guz.Name = "guzi";
            guz.Width = 100;
            guz.Height = 50;
            guz.Content = "OK";
            guz.VerticalAlignment=VerticalAlignment.Bottom;
            guz.Margin = new Thickness(10);
            guz.Click += guzi_Click;
            cos.Children.Add(tekst);
            cos.Children.Add(guz);
            poup.Content = cos;
            poup.Show();
        }
        private void guzi_Click(object sender, RoutedEventArgs e) //OK
        {
            input = tekst.Text;
            cos.Children.Remove(tekst);
            ZapiszDatyUsera();
            tekst.Clear();
            poup.Hide();
            odczytajDatyDomyslne();
            odczytajDatyUsera();
        }
        public void ZapiszDatyUsera()
        {
            StreamWriter tw = new StreamWriter("daty.txt", append:true);
            tw.WriteLine(zawartosc + tabDD[1] + tabDD[2] + "|" + input);
            tw.Close();
        }
        private void Okno_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            poup.Close();
        }
        private void Wlewo(object sender, RoutedEventArgs e)
        {
            int flaga = 0;
            string tmp = "";
            string czytaj;
            string[] dziel;
            StreamReader tr = new StreamReader("daty.txt");
            while (!tr.EndOfStream)
            {
                czytaj = tr.ReadLine();
                dziel = czytaj.Split('|');
                if (dziel[0] == (zawartosc + tabDD[1] + tabDD[2]) && flaga == 0 && dziel[1] == pomoc) {
                    tmp = pomoc;
                    break;
                }
                else
                {
                    if (dziel[0] == (zawartosc + tabDD[1]+ tabDD[2]) && dziel[1] == pomoc) break;
                    if (dziel[0] == (zawartosc + tabDD[1]+tabDD[2]))
                    {
                        tmp = dziel[1];
                    }
                }
                if (dziel[0] == (zawartosc + tabDD[1]+ tabDD[2]))
                {
                    flaga = 1;
                }
            }
            bot.Text = tmp;
            pomoc = tmp;
        }
        private void Wprawo(object sender, RoutedEventArgs e)
        {
            string tmp = "";
            int flaga = 1;
            bool fl = false;
            string czytaj;
            string[] dziel;
            StreamReader tr = new StreamReader("daty.txt");
            while (!tr.EndOfStream)
            {
                czytaj = tr.ReadLine();
                dziel = czytaj.Split('|');
                if((dziel[0] == (zawartosc + tabDD[1]+tabDD[2])) && flaga == 0)
                {
                    fl = true;
                    tmp = dziel[1];
                    break;
                }
                if ((dziel[0] == (zawartosc + tabDD[1]+tabDD[2])) && pomoc == dziel[1])
                {
                    flaga = 0;
                }
            }
            if (!fl)
            {
                bot.Text = pomoc;
            }
            else
            {
                bot.Text = tmp;
                pomoc = tmp;
            }
        }
    }
}